//
//  PlayerViewController.swift
//  AmpFreewheelSample
//
//  Created by Lopez Valenciano, Miguel on 12/11/17.
//  Copyright © 2023 Akamai. All rights reserved.
//

import Foundation
import AmpCore
import AmpFreewheel

class PlayerViewController: UIViewController {
    
    var ampPlayer: AmpPlayer!
    var ampFreewheel: AmpFreewheelManager!
    var levels:[QualityLevel]!
    var firstLoad:Bool = true
        
    let vod = "https://bitdash-a.akamaihd.net/content/sintel/hls/playlist.m3u8"
    let live = "http://playertest.longtailvideo.com/adaptive/wowzaid3/playlist.m3u8"
    let audio = "http://nrkradio-f.akamaihd.net/i/p3_0@4275/master.m3u8"
    let shortVOD = "http://cdnbakmi.kaltura.com/p/243342/sp/24334200/playManifest/entryId/0_uka1msg4/flavorIds/1_vqhfu6uy,1_80sohj7p/format/applehttp/protocol/http/a.m3u8"
    
    override func viewDidLoad() {
        super.viewDidLoad()
        
        self.ampPlayer = AmpPlayer(parentView: self.view)
        self.ampFreewheel = AmpFreewheelManager(ampPlayer: ampPlayer!, networkId: 42015)
        self.ampPlayer.isPictureInPictureEnabled = true
        self.ampPlayer.setLicense("AwETtTXPRsvmp2oSjsKviO6DmucyCu1Lw/+590XuBHO91ePfqtGzVx1Ewrc5Lt+YWShxO5by03IIo5k0zHlY/CIPl9H5fpgV/BkubsJXWffQN9HIJthoAvH+zr142zvOZkIQFnLByWyWjSs0xcqfOEHK/xyvNshy3zdmGgfS4ol9oSY2QGP6WFMTT86pGkHCVr6Tr6vPX0PUBMf33mu/hHgszAL2uD5hNPLGKR7ZaBhwQQ==")
        self.ampPlayer.registerObserver(self)
        self.ampPlayer.setThumbnail(url: "https://mdtp-a.akamaihd.net/preview/preview.vtt", path: "https://mdtp-a.akamaihd.net/preview/")
        
        ampFreewheel.requestAds(serverUrl: "http://demo.v.fwmrm.net", profile: "42015:ios_allinone_profile", siteSectionId: "ios_allinone_demo_site_section", videoAssetId: VideoAssetId(id: "ios_allinone_demo_video", duration: 500)){adController in
            adController.addPrerollSlot("pre1")
            adController.addMidrollSlot("mid1", timePosition: 15)
            adController.addMidrollSlot("mid2", timePosition: 30)
            adController.addPostrollSlot("post1")}
        print("AKAMAI PLAYER VERSION: \(self.ampPlayer!.version)")
        self.ampPlayer.setThumbnail(url: "https://mdtp-a.akamaihd.net/preview/preview.vtt", path: "https://mdtp-a.akamaihd.net/preview/")
        self.ampPlayer.play(url: shortVOD)
        self.ampFreewheel.isLearnMoreButtonEnabled = false
    }
    
    override func didReceiveMemoryWarning() {
        super.didReceiveMemoryWarning()
        // Dispose of any resources that can be recreated.
    }
    
}


extension PlayerViewController: PlayerEventObserver {
    
    func onBufferingStateChanged(_ ampPlayer: AmpPlayer) {
        print("FWEVENT: bufferStateChanged \(ampPlayer.bufferingState.description)")
    }
    
    func onAdBreakStarted(break: AdBreakInfo?) {
        print("FWEVENT: onAdBreakStarted")
    }
    
    func onAdBreakEnded(break: AdBreakInfo?) {
        print("FWEVENT: onAdBreakEnded")
    }
    
    func onAdStarted(ad: AdInfo?) {
        print("FWEVENT: onAdStarted")
    }
    
    func onAdError() {
        print("FWEVENT: onAdError")
    }
    
    func onAdEnded(ad: AdInfo?) {
        print("FWEVENT: onAdEnded")
    }
    
    func onAdRequestCompleted() {
        print("FWEVENT: onAdRequestCompleted")
    }
    
    func onAdRequested() {
        print("FWEVENT: onAdRequested")
    }
    
}
